Scriptname HypoFireScan extends Quest 
{Hypothermia script that checks for fire near player}

; Authors: Nitor and McGuffin


GlobalVariable Property HypoEnableAnimations auto
GlobalVariable Property HypoFireInterval auto

Spell Property zWarmingFire auto
Spell Property zWarmingHands auto

float firewarmradiussmall = 170.0
float firewarmradius = 450.0
float firewarmradiusgiant = 800.0

FormList Property HypoFiresCommon auto
FormList Property HypoFiresUncommon auto
FormList Property HypoFiresGiant auto
FormList Property HypoFiresSmall auto
FormList Property HypoFiresFurniture auto

int updates = 0
int iterations = 4		;Number of iterations to check for common fires before switching to uncommon

int verticalThreshold = 200	;Z distance from player that a fire will give warmth

bool nearcommonfire = false

bool function FindFireRef(formlist fList, Actor aRef, float fRad, bool applywarmhands)
	ObjectReference oFireRef = Game.FindClosestReferenceOfAnyTypeInListFromRef( fList, aRef as ObjectReference, fRad )
	
	bool isFireValid = oFireRef && oFireRef.IsEnabled() && ( Math.abs(oFireRef.Z - aRef.Z) < verticalThreshold)
	
	if (applywarmhands && isFireValid && (HypoEnableAnimations.GetValue() > 0))
		float tmpang = aRef.GetHeadingAngle(oFireRef)	
		if (!aRef.HasSpell(zWarmingHands)  && aRef.GetDistance(oFireRef) < 190 && Math.abs(tmpang) < 15) 	; Find warm hands animation sweetspot		
			Utility.Wait(3) ;lets check if we dont move for 3 secs
			if (!aRef.HasSpell(zWarmingHands) && tmpang == aRef.GetHeadingAngle(oFireRef)) ;if the angle is the same, we can assume we didnt move
				aRef.AddSpell(zWarmingHands, false)
			endif
		endif		
	endif	
	
	return isFireValid 
EndFunction

State COMMON

	Event OnUpdate ()

		Actor akActor = Game.GetPlayer()
		
		if FindFireRef( HypoFiresCommon, akActor, firewarmradius, true)
			;Debug.Trace("HYPOTHERMIA FIRESCANNER: Found a common fire")
			akActor.AddSpell(zWarmingFire, false)
			nearcommonfire = true
		elseif FindFireRef( HypoFiresFurniture, akActor, firewarmradius, true)
			;Debug.Trace("HYPOTHERMIA FIRESCANNER: Found a furniture fire")
			akActor.AddSpell(zWarmingFire, false)
			nearcommonfire = true
		elseif FindFireRef( HypoFiresGiant, akActor, firewarmradiusgiant, false) 
			;Debug.Trace("HYPOTHERMIA FIRESCANNER: Found a giant fire")
			akActor.AddSpell(zWarmingFire, false)
			nearcommonfire = true
		else
			nearcommonfire = false
		endif
		
		updates += 1
		
		if (updates > iterations)
			updates = 0
			GoToState("UNCOMMON")
		endif
		
		RegisterForSingleUpdate(HypoFireInterval.GetValue())
		
	EndEvent
		
EndState
		
State UNCOMMON

	Event OnUpdate ()
	
		Actor akActor = Game.GetPlayer()
	
		if FindFireRef( HypoFiresUncommon, akActor, firewarmradius, true)
			;Debug.Trace("HYPOTHERMIA FIRESCANNER: Found an uncommon fire")
			akActor.AddSpell(zWarmingFire, false)
		elseif FindFireRef( HypoFiresSmall, akActor, firewarmradiussmall, false)
			;Debug.Trace("HYPOTHERMIA FIRESCANNER: Found a uncommon small fire")
			akActor.AddSpell(zWarmingFire, false)
		elseif (!nearcommonfire)
			;Debug.Trace("HYPOTHERMIA FIRESCANNER: No fires")
			akActor.RemoveSpell(zWarmingFire)
			akActor.RemoveSpell(zWarmingHands)
		endif
		
		GoToState("COMMON")
		
		RegisterForSingleUpdate(HypoFireInterval.GetValue())

	EndEvent

EndState


Event OnInit ()
	RegisterForSingleUpdate(HypoFireInterval.GetValue())
	RegisterForSleep()
	GoToState("COMMON")
EndEvent

Event OnSleepStop(bool abInterrupted)

	RegisterForSingleUpdate(HypoFireInterval.GetValue())
EndEvent
