Scriptname HypoPlayerListenerScript extends ReferenceAlias  
{Attaches to player alias in Hypothermia Quest and receives OnObjectEquipped events to force applicable armor to reference aliases that assign keywords.}

Hypothermia Property HypoScript auto

Spell Property zHypoWarmClothes2 auto
Spell Property zHypoWarmClothes3 auto
Spell Property zHypoWarmExtra2 auto
Spell Property zHypoWarmExtra3 auto
Spell Property zHypoWarmHood auto
Spell Property zHypoCloak auto

FormList Property HypoWarmApparel2 auto
FormList Property HypoWarmApparel3 auto
FormList Property HypoHoodedApparel auto

Keyword Property ArmorClothing auto
Keyword Property ClothingNecklace auto


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Foods and Effects
FormList Property HypoWarmingFoods auto
Ingredient Property Snowberry auto

Spell Property zHypoSoup auto
Spell Property zHypoSnowberry auto


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Globals
GlobalVariable Property HypoCaveTempAdjust auto
GlobalVariable Property HypoMineTempAdjust auto
GlobalVariable Property HypoFortTempAdjust auto
GlobalVariable Property HypoIceCaveTempAdjust auto
GlobalVariable Property HypoDwarvenTempAdjust auto
GlobalVariable Property HypoNordicTempAdjust auto

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Location Set Keywords
Keyword Property LocSetCave auto
Keyword Property LocSetCaveIce auto
Keyword Property LocSetDwarvenRuin auto
Keyword Property LocSetMilitaryCamp auto
Keyword Property LocSetMilitaryFort auto
Keyword Property LocSetNordicRuin auto

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Location Type Keywords
Keyword Property LocTypeMilitaryFort auto
Keyword Property LocTypeMine auto
Keyword Property LocTypeAnimalDen auto

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Current Location Variable
Location Property akLoc auto


Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)

	Actor pc = Game.GetPlayer()

	if (akBaseObject as Armor)																				; Check armors
	
		if ( StringUtil.Find(akBaseObject.GetName(), "Cloak") > -1 || StringUtil.Find(akBaseObject.GetName(), "Cape") > -1 )	; Cloaks and Capes
			pc.AddSpell(zHypoCloak, false)
			HypoScript.SetSaturationWetRate(0.0003)
			;Debug.Notification("HypoPlayerAlias: OnObjectEquipped - Cloak")
			
		elseif ( HypoWarmApparel2.HasForm(akBaseObject) || akBaseObject.HasKeywordString("WarmClothes2") || akBaseObject.HasKeywordString("Warm"))
			pc.AddSpell(zHypoWarmClothes2, false)
			;Debug.Notification("HypoPlayerAlias: OnObjectEquipped - Warm2 : " + akBaseObject.GetName())
			
		elseif ( HypoWarmApparel3.HasForm(akBaseObject) || akBaseObject.HasKeywordString("WarmClothes3") || akBaseObject.HasKeywordString("VeryWarm"))
			pc.AddSpell(zHypoWarmClothes3, false)
			;Debug.Notification("HypoPlayerAlias: OnObjectEquipped - Warm3")
			
		else
			;Debug.Notification("HypoPlayerAlias: OnObjectEquipped - Armor")
		endif
		
		if ( StringUtil.Find(akBaseObject.GetName(), "Hood") > -1 )											; Hoods
			pc.AddSpell(zHypoWarmHood, false)
		endif
		
	elseif (akBaseObject as Potion)											
		;Debug.Notification("HypoPlayerAlias: OnObjectEquipped - Consumable")
		if ( HypoWarmingFoods.HasForm(akBaseObject) )
			zHypoSoup.Cast(pc, pc)
			;Debug.Notification("Hypo: Ate stew or soup")
		endif
		
	elseif (akBaseObject as Ingredient)
		if ( akBaseObject == (Snowberry as Form) )
			zHypoSnowberry.Cast(pc, pc)
			;Debug.Notification("Hypo: Ate snowberry")
		endif
		
	endif
	
	

EndEvent

Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)

	Actor pc = Game.GetPlayer()

	if (akBaseObject as Armor)													; Check armors
	
		if ( StringUtil.Find(akBaseObject.GetName(), "Cloak") > -1 || StringUtil.Find(akBaseObject.GetName(), "Cape") > -1 )			; Cloaks and Capes
			pc.RemoveSpell(zHypoCloak)
			HypoScript.SetSaturationWetRate(0.003)
			;Debug.Notification("HypoPlayerAlias: OnObjectUnequipped - Cloak")
			
		elseif ( HypoWarmApparel2.HasForm(akBaseObject) || akBaseObject.HasKeywordString("WarmClothes2") || akBaseObject.HasKeywordString("Warm") )
			if (!HypoWarmApparel2.HasForm(pc.GetWornForm(0x00000004)))
				pc.RemoveSpell(zHypoWarmClothes2)
			endif
			;Debug.Notification("HypoPlayerAlias: OnObjectUnequipped - Warm2")
			
		elseif ( HypoWarmApparel3.HasForm(akBaseObject) || akBaseObject.HasKeywordString("WarmClothes3") || akBaseObject.HasKeywordString("VeryWarm"))
			if (!HypoWarmApparel3.HasForm(pc.GetWornForm(0x00000004)))
				pc.RemoveSpell(zHypoWarmClothes3)
			endif
			;Debug.Notification("HypoPlayerAlias: OnObjectUnequipped - Warm3")
			
		else
			;Debug.Notification("HypoPlayerAlias: OnObjectUnequipped - Armor")
		endif
		
		if ( StringUtil.Find(akBaseObject.GetName(), "Hood") > -1 )				; Hoods
			pc.RemoveSpell(zHypoWarmHood)
		endif
		
	else																		; Default to standard
		;Debug.Notification("HypoPlayerAlias: OnObjectUnequipped - Normal")
	endif


EndEvent


Event OnLocationChange (Location akOldLoc, Location akNewLoc)			
	akLoc = akNewLoc
	;Debug.Notification("New location: " + akNewLoc.GetFormID() + " " + akNewLoc.GetName())
	;Debug.Notification("Worldspace: " + GetActorReference().getWorldspace().GetName())
EndEvent


Event OnCellLoad()
	
	;Debug.Notification("OnCellLoad, location: " + akLoc.GetFormID() )
	
	;Nordic Ruins
	if ( akLoc.HasKeyword(LocSetNordicRuin) && GetActorRef().IsInInterior() )
		HypoScript.ModAmbientTemp(HypoNordicTempAdjust.GetValue())
		
	;Dwemer Ruins
	elseif ( akLoc.HasKeyword(LocSetDwarvenRuin) && GetActorRef().IsInInterior() )
		HypoScript.ModAmbientTemp(HypoDwarvenTempAdjust.GetValue())
	
	;Forts
	elseif ( (akLoc.HasKeyword(LocTypeMilitaryFort) || akLoc.HasKeyword(LocSetMilitaryFort)) && GetActorRef().IsInInterior() )
		HypoScript.ModAmbientTemp(HypoFortTempAdjust.GetValue())
	
	;Mine
	elseif ( akLoc.HasKeyword(LocTypeMine) && GetActorRef().IsInInterior() )
		HypoScript.ModAmbientTemp(HypoMineTempAdjust.GetValue())
	
	;Ice Caves
	elseif ( akLoc.HasKeyword(LocSetCaveIce) && GetActorRef().IsInInterior() )
		HypoScript.ModAmbientTemp(HypoIceCaveTempAdjust.GetValue())
		
	;Caves
	elseif ( (akLoc.HasKeyword(LocSetCave) || akLoc.HasKeyword(LocTypeAnimalDen)) && GetActorRef().IsInInterior() )
		HypoScript.ModAmbientTemp(HypoCaveTempAdjust.GetValue())
	
	else
		HypoScript.ModAmbientTemp(0)
	endif
	
EndEvent
